program cont_at;

{ Continues (finishes) execution at a specified time }
{ syntax:   CONT_AT hh:mm                 }

uses Dos, Crt;

var
  h1, h2, m1, m2, m3, sec, hund : Word;
  err : Integer;
  s : String;

begin
  s := paramstr(1);
  if pos(':',s) > 0 then begin
    val(copy(s,1,pos(':',s)-1), h2, err);
    if err = 0 then begin
      val(copy(s,pos(':',s)+1,length(s)), m2, err);
    end
  end
  else begin
    err := 1;
  end;
  if (err <> 0) or (h2 < 0) or (h2 > 23) or (m2 < 0) or (m2 > 59) then begin
    writeln;
    writeln('Error: Correct syntax is CONT_AT hh:mm');
    halt;
  end;

  writeln('Waiting until ', s, '.  Press Shift-Shift to exit early.');

  m3 := 999;
  repeat
    GetTime(h1,m1,sec,hund);
    if m1 <> m3 then begin
      m3 := m1;
      gotoxy(1,wherey);
{      if m1 >= 10 then write(h1:2,':',m1:2) else write(h1:2,':0',m2:1); }
      if m1 >= 10 then write(h1:2,':',m1:2) else write(h1:2,':0',m1:1);
    end;
  until ((h1 = h2) and (m1 = m2)) or ((mem[64:23] and 3) = 3);

  writeln;
  end.
