PROGRAM HEXFREQ(FILEIN);
VAR
  FILEIN: FILE;
  NAME: STRING[20];
  BUF : ARRAY[1..128] OF CHAR;
  FREQ: ARRAY[0..255] OF INTEGER;
  N,I,R,C       : INTEGER;
BEGIN
  FOR I:=0 TO 255 DO FREQ[I]:=0;
  IF PARAMSTR(1) = '' THEN BEGIN
    WRITE('ENTER FILE TO FIND HEX FREQUENCY OF : ');
    READLN(NAME);
    END
  ELSE NAME := PARAMSTR(1);
  ASSIGN(FILEIN,NAME);
  RESET(FILEIN,1);
  N:=FILESIZE(FILEIN);
  WRITELN('FILE SIZE IS ',N);
  WHILE NOT EOF(FILEIN) DO BEGIN
    BLOCKREAD(FILEIN,BUF,128,N);
    FOR I:=1 TO N DO FREQ[ORD(BUF[I])]:=FREQ[ORD(BUF[I])]+1;
    END;
  CLOSE(FILEIN);
  WRITELN('THE FREQUENCY OF EACH BYTE TYPE IS:  (ROW IS MSD, COL IS LSD)');
  WRITELN;
  WRITE('   ');
  FOR C:=0 TO 15 DO IF C<10 THEN WRITE(C:4) ELSE WRITE('   ',CHR(C+55));
  WRITELN;WRITELN;
  FOR R:=0 TO 15 DO BEGIN
    IF R<10 THEN WRITE(R:1,' |') ELSE WRITE(CHR(R+55),' |');
    FOR C:=0 TO 15 DO IF FREQ[R*16+C]=0 THEN WRITE('    ')
                                        ELSE WRITE(FREQ[R*16+C]:4);
    WRITELN
    END
  END.