program addpause;

var
  filein   :text;
  fileout  :text;
  line     :string[255];

begin {main}
  if (paramstr(1) = '') or (paramstr(1) = paramstr(2)) then begin
    writeln;
    writeln('  ADDPAUSE infile outfile');
    writeln;
    writeln('    Adds PAUSE statements before every line of infile.');
    writeln('    Used to allow stepping thru BAT files.');
    writeln('    infile name must be different than outfile.');
    writeln;
    halt;
  end;
  assign(filein,paramstr(1));
  reset(filein);
  assign(fileout,paramstr(2));
  rewrite(fileout);
  repeat
    readln(filein,line);
    writeln(fileout,'PAUSE');
    writeln(fileout,line);
    until eof(filein);
  close(filein);
  close(fileout);
end.
