{d$i-}
{$r+}
{$m 65520,0,655360}

Program chksum;

Uses DOS;
var
  current_dir : string;
  do_sub_dirs : boolean;
  do_file_sums : boolean;
  do_help : boolean;
  i : integer;
  arg : string;

procedure do_this_dir(current_dir:string);

Var DirInfo : SearchRec;                           { Turbo Directory Record }
    Path : String;
    check_sum   : longint;
    f : file;
    file_name : string;
    buf : array[1..4096] of byte;
    i, n : word;
    subdir : array[1..100] of string[50];
    n_subdirs : integer;
    check_sum_total   : longint;

Begin
  check_sum_total := 0;
  n_subdirs:=0;
  Path := current_dir + '\*.*';
  FindFirst (Path,Directory,DirInfo);    { First entry in current directory }
  While (DOSError = 0) Do Begin
    If (DirInfo.Attr = 16) and (DirInfo.Name[1] <> '.') Then begin
      n_subdirs := n_subdirs+1;
      subdir[n_subdirs] := (copy(path,1,length(path)-3)+dirinfo.name);
    end
    else if dirinfo.name[1] = '.' then {do nothing}
    else begin
      file_name := copy(path,1,length(path)-3)+dirinfo.name;
      assign(f,file_name);
      {$i-}
      reset(f, 1);
      {$i+}
      if ioresult = 0 then begin
        check_sum := 0;
        repeat
         {$i-}
          blockread(f,buf,sizeof(buf),n);
          {$i+}
          if ioresult = 0 then begin
            for i:= 1 to n do check_sum :=check_sum + buf[i] xor i;
          end
          else begin
            writeln('I/O error reading:':23,file_name);
          end;
        until(n = 0);
        close(f);
        if do_file_sums then writeln (check_sum:20,'   ',file_name);
        check_sum_total := check_sum_total + check_sum;
      end
      else begin
        writeln('Cannot open:':23,file_name);
      end;
    end;
    FindNext (DirInfo);                             { Get next file record  }
    End;
    writeln('Total = ':8, check_sum_total:12,'   ',current_dir);

    if do_sub_dirs then for i := 1 to n_subdirs do do_this_dir(subdir[i]);
  end;

begin {main}

  filemode := 0; {Allows opening of readonly files.  See page 106}
  do_sub_dirs := false;
  do_file_sums := true;
  do_help := false;
  current_dir := fexpand('.');
  if paramcount > 3 then do_help := true;
  for i := 1 to ParamCount do begin
    arg := ParamStr(i);
    if (arg[1] = '/') and
       (length(arg) = 2) and
       (upcase(arg[2]) = 'S') then do_sub_dirs := true
    else if (arg[1] = '/') and
       (length(arg) = 2) and
       (upcase(arg[2]) = 'D') then do_file_sums := false
    else if (arg[1] = '/') and
       (length(arg) = 2) and
       (upcase(arg[2]) in ['H', '?']) then do_help := true
    else current_dir := arg;
  end;

  if do_help then begin
    writeln('CHKSUM computes the check sum of a set of files.');
    writeln('Syntax: CHKSUM [[drive:]directory] [/s] [/d]');
    writeln('  /s process specified directory and its subdirectories');
    writeln('  /d show directory check sums totals only (else file and directory check sums)');
    halt;
  end;

  do_this_dir(current_dir);

end.
