{ possible upgrades:   }
{   wild cards         }


Program save;

{$M $4000,0,$4000 }   { 16K stack & heap }

Uses DOS;

Var
  DirInfo      : SearchRec; { Turbo Directory Record }
  Path         : String;
  filename_ext : string;
  filename     : string;
  ext          : string[3];
  highest_ext  : string[3];
  p            : integer;
  numeric      : boolean;

function exists(var filename_of_any_string_length):boolean;
var
  filename : string[255] absolute filename_of_any_string_length;
  filein : file;
begin
  assign(filein,filename);
  {$I-}
  reset(filein);
  {$I+}
  if ioresult = 0 then begin
    exists:=true;
    close(filein);
  end
  else exists:=false;
end; {exists}

Begin
  If ParamStr(1) = '' Then begin
    writeln('SAVE file_name.ext  : Copies file_name.ext to file_name.nnn,');
    writeln('                      where nnn is one greater than the highest');
    writeln('                      existing sequence number for this file.');
    writeln('                      If no sequence number exists, SAVE uses 001.');
    writeln('                      An optional second parameter can be entered');
    writeln('                      to specify the value of nnn.');
    halt;
  end;
  filename_ext := ParamStr(1);

  {quit if file does not exist}
  if not exists(filename_ext) then begin
    writeln('Error: input file does not exist.  Type SAVE for help.');
    halt;
  end;

  {strip ext off filename_ext --> filename}
  p := length(filename_ext);
  while (p > 0) and (filename_ext[p] <> '.') do dec(p); {search backwards for .}
  if p = 0 then filename := filename_ext
  else filename := copy(filename_ext, 1, p-1);

  {paramstr(2) may override nnn}
  ext := paramstr(2);
  if (length(ext) > 0) then begin
    if (length(ext) = 3) and
       (ext[1] in ['0'..'9']) and
       (ext[2] in ['0'..'9']) and
       (ext[3] in ['0'..'9']) then highest_ext := ext
    else begin
      writeln('Error: Invalid ext in parameter 2.  Type SAVE for help.');
      halt;
    end;
  end
  else begin {search for highest numbered ext}
    highest_ext := '000';

    Path := filename + '.*';
    FindFirst (Path, Anyfile, DirInfo);
    While (DOSError = 0) Do Begin

      {extract ext}
      p := pos('.', DirInfo.Name);
      if p = 0 then ext := ''
      else ext := copy(DirInfo.Name, p+1, 3);

      {is ext all numeric?}
      numeric := length(ext) = 3;
      if numeric then for p := 1 to 3 do begin
        if not (ext[p] in ['0'..'9']) then numeric := false;
      end;

      if numeric then begin
        if ext > highest_ext then highest_ext := ext;
      end;

      FindNext (DirInfo);
    End;

    {add one to highest_ext}
    if highest_ext = '999' then begin
      writeln('Error: No available next highest seq # (.999 exists).  Type SAVE for help.');
      halt;
    end;
    highest_ext[3] := char(byte(highest_ext[3]) + 1);
    if highest_ext[3] > '9' then begin
      highest_ext[3] := '0';
      highest_ext[2] := char(byte(highest_ext[2]) + 1);
      if highest_ext[2] > '9' then begin
        highest_ext[2] := '0';
        highest_ext[1] := char(byte(highest_ext[1]) + 1);
      end;
    end;
  end;

  {copy it}
  write('Copying ', filename_ext, ' to ', filename, '.', highest_ext);
  exec(getenv('COMSPEC'),'/c copy ' + filename_ext + ' ' + filename + '.' + highest_ext);
  writeln;

End.
