program color(input,output,filein,fileout);

var
  filein   :text;
  filename :string[40];
  i        :integer;
  line     :string[255];

begin {main}
  if paramcount > 0 then  filename:=paramstr(1)
  else begin
    writeln('This program displays files in color.');
    writeln('If you are unfamiliar with SEECOLOR, enter SEECOLOR.SEE below.');
    writeln;
    write('File name to see in color (default extension is .see) ? ');
    readln(filename);
    end;
  if pos('.',filename) = 0 then filename:=filename+'.see';
  assign(filein,filename);
  reset(filein);
  textmode(c40);
  textbackground(15);
  clrscr;
  repeat
    readln(filein,line);
    i:=1;
    while i <= length(line) do begin
      if line[i] = '~' then begin
        i:=i+1;
        case line[i] of
          '~' : write('~');
          '/' : begin
            readln;
            clrscr;
            end;
          'A'..'P': textcolor(ord(line[i])-ord('A'));
          end;
        end
      else begin
        write(line[i]);
        end;
      i:=i+1;
      end;
    writeln; write('   ');
    until eof(filein);
  readln;
  close(filein);
  textmode(c80);
  end.
