program which;

uses dos, crt, e_proc;

var
  DirInfo: SearchRec;
  cmd_name:string;
  EXE_file:string;
  COM_file:string;
  BAT_file:string;
  path:string;
  i:byte;
  p:byte;
  next:string;
  n_found:integer;
  bat_names : string;
  answer : char;

function next_dir(path:string; var p:byte):string;
var
  s:string;
begin
  if p = 0 then begin
    next_dir := '';
    inc(p);
  end
  else begin
    path := path + ';';
    s := '';
    while path[p] <> ';' do begin
      s := s + path[p];
      inc(p);
    end;
    inc(p);
    if s[length(s)] = '\' then next_dir := s else next_dir := s+'\';
  end;
end;

begin {main}
  if paramcount = 0 then begin
    writeln;
    write('Command name(s) to search for on the path, e.g. ED* : ');
    readln(cmd_name);
  end
  else cmd_name := paramstr(1);

  for i := 1 to length(cmd_name) do cmd_name[i] := upcase(cmd_name[i]);

  path := getenv('PATH');

  writeln;
  writeln('Searching for "', cmd_name, '" on the path.');
  writeln;
  writeln('The current path is ', path);
  writeln;

  p := 0;
  n_found := 0;
  bat_names := '';
  while p < length(path) do begin
    next := next_dir(path,p);
    findfirst(next+cmd_name+'.EXE',anyfile,dirinfo);
    while DOSError = 0 do begin
      inc(n_found);
      WriteLn('Found ',next+DirInfo.Name);
      findnext (dirinfo);
    end;
    findfirst(next+cmd_name+'.COM',anyfile,dirinfo);
    while DOSError = 0 do begin
      inc(n_found);
      WriteLn('Found ',next+DirInfo.Name);
      findnext (dirinfo);
    end;
    findfirst(next+cmd_name+'.BAT',anyfile,dirinfo);
    while DOSError = 0 do begin
      inc(n_found);
      WriteLn('Found ',next+DirInfo.Name);
      bat_names := bat_names + next + DirInfo.Name + ' ';
      findnext (dirinfo);
    end;
  end;
  if n_found = 0 then writeln('Command "', cmd_name, '" not found.')
  else begin
    if n_found > 1 then writeln(n_found, ' commands found.');
    if bat_names <> '' then begin
      write('Edit or view the .BAT file(s) ? ');
      answer := readkey;
      if upcase(answer) = 'Y' then e(bat_names);
    end;
  end;
end.
